namespace VSTO_CSOutlookTemplate
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Runtime.InteropServices;
    using Outlook = Microsoft.Office.Interop.Outlook;
    using Office = Microsoft.Office.Core;
    using System.Windows.Forms;
    using stdole;

    class ExplWrap
    {
        private Outlook.Explorer m_Expl = null;
        private Outlook.ExplorerClass m_ExplClass = null;

        private int m_ID = 0;

        private bool m_Startup = false;

        private bool m_Killed = false;

        private System.Collections.SortedList m_WrapperClass = null;

        private Office.CommandBarButton m_button = null;

        private Office.CommandBarPopup m_pop = null;

        public System.Collections.SortedList WrapperClass
        {
            get
            {
                return m_WrapperClass;
            }

            set
            {
                m_WrapperClass = value;
            }
        }

        public Outlook.Explorer Explorer
        {
            get
            {
                return m_Expl;
            }

            set
            {
                m_Expl = value;

                m_Startup = true;

                m_ExplClass = (Outlook.ExplorerClass)m_Expl;

                // hook up the Close event handler
                m_ExplClass.ExplorerEvents_Event_Close += new Outlook.ExplorerEvents_CloseEventHandler(m_Expl_Close);

                // hook up the Activate event handler
                m_ExplClass.ExplorerEvents_Event_Activate += new Outlook.ExplorerEvents_ActivateEventHandler(m_Expl_Activate);

                // hook up the SelectionChange event handler
                m_Expl.SelectionChange += new Outlook.ExplorerEvents_10_SelectionChangeEventHandler(m_Expl_SelectionChange);

                m_Killed = false;
                m_Startup = true;
            }
        }

        public int Key
        {
            get
            {
                return m_ID;
            }

            set
            {
                m_ID = value;
            }
        }

        private void m_Expl_Activate()
        {
            DoStartup();
        }

        private void m_Expl_SelectionChange()
        {
            DoStartup();
        }

        private void DoStartup()
        {
            // change the UI and Tag strings for your own addin
            string ProgID = ThisAddIn.AddinObject.ProgID();
            Office.CommandBar bar = m_Expl.CommandBars["Menu Bar"];
            CommandBarsMaker buttonMaker = new CommandBarsMaker();
            
            if (m_Startup == true)
            {
                if (m_button == null)
                {
                    try
                    {
                        // change the UI and Tag strings for your own addin
                        string idMenu = "ExplTestMenu" + Key.ToString();
                        string id = "ExplTestButton" + Key.ToString();

                        Office.MsoButtonStyle Style = Office.MsoButtonStyle.msoButtonIconAndCaption;

                        // change the UI and Tag strings for your own addin
                        m_pop = buttonMaker.NewMenu(bar, "VSTO_CSOutlookTemplate", idMenu, true, ProgID, true, "Custom Menu", true);
                        if (m_pop != null)
                        {
                            // change the UI and Tag strings for your own addin
                            m_button = buttonMaker.NewButton(m_pop.CommandBar, "Test Button", id, true, ProgID, Style, false, "Test", true);

                            if (m_button != null)
                            {
                                m_button.Click += new Office._CommandBarButtonEvents_ClickEventHandler(m_button_Click);

                                // add an icon to the button
                                System.Drawing.Image imgStreamPic;
                                IPictureDisp oPic = null;
                                MyAxHost ax = new MyAxHost();

                                imgStreamPic = VSTO_CSOutlookTemplate.Properties.Resources.INFO.ToBitmap();

                                oPic = ax.IPictureDispFromImage(imgStreamPic);
                                m_button.Picture = oPic;

                                imgStreamPic = null;
                                ax = null;
                                oPic = null;
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                }
                m_Startup = false;
            }
            bar = null;
            buttonMaker = null;
        }

        private void m_Expl_Close()
        {
            if (m_Killed == false)
            {
                m_Killed = true;

                OutExpl killer = new OutExpl();
                killer.KillExpl(m_ID, m_WrapperClass);
                killer = null;

                m_WrapperClass = null;

                // release the Close event handler
                m_ExplClass.ExplorerEvents_Event_Close -= new Outlook.ExplorerEvents_CloseEventHandler(m_Expl_Close);

                // release the Activate handler
                m_ExplClass.ExplorerEvents_Event_Activate -= new Outlook.ExplorerEvents_ActivateEventHandler(m_Expl_Activate);

                // release the SelectionChange handler
                m_Expl.SelectionChange -= new Outlook.ExplorerEvents_10_SelectionChangeEventHandler(m_Expl_SelectionChange);

                if (m_pop != null)
                {
                    if (m_button != null)
                    {
                        m_button.Click -= new Office._CommandBarButtonEvents_ClickEventHandler(m_button_Click);
                        m_button.Delete(false);
                    }
                    m_pop = null;
                }

                if (m_Expl != null) { m_Expl = null; }
                if (m_ExplClass != null) { m_ExplClass = null; }
                if (m_button != null) { m_button = null; }
            }
        }

        private void m_button_Click(Microsoft.Office.Core.CommandBarButton Ctrl, ref bool CancelDefault)
        {
            MessageBox.Show(Ctrl.Caption + " was just clicked");
        }
    }
}