namespace VSTO_CSOutlookTemplate
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using Outlook = Microsoft.Office.Interop.Outlook;
    using Office = Microsoft.Office.Core;
    using System.Windows.Forms;
    using Microsoft.Office.Tools;

    class OutInsp
    {
        public int AddInsp(Outlook.Inspector Inspector, int WrapperID,
            Outlook.OlObjectClass InspectorType, ref System.Collections.SortedList WrapperCol,
            Office.CustomTaskPane Pane, TimeTravelFormRegionWrapper Region,
            Office.IRibbonUI Ribbon)
        {
            InspWrap objInspWrap = new InspWrap();
            Outlook.MailItem oMail = null;
            Outlook.AppointmentItem oAppt = null;

            switch (InspectorType)
            {
                case Outlook.OlObjectClass.olMail:
                    try
                    {
                        oMail = (Outlook.MailItem)Inspector.CurrentItem;
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }

                    if (oMail != null)
                    {
                        try
                        {
                            objInspWrap.Inspector = Inspector;
                            objInspWrap.MailItem = oMail;
                            objInspWrap.Key = WrapperID;
                            objInspWrap.WrapperClass = WrapperCol;
                            objInspWrap.TaskPane = Pane;
                            objInspWrap.Region = null;
                            objInspWrap.Ribbon = Ribbon;
                            objInspWrap.AppointmentItem = null;

                            // add wrapper class to the collection to keep it alive
                            WrapperCol.Add(WrapperID, objInspWrap);

                            WrapperID += 1;
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show(ex.Message);
                        }
                    }
                    break;
                case Outlook.OlObjectClass.olAppointment:
                    try
                    {
                        oAppt = (Outlook.AppointmentItem)Inspector.CurrentItem;
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }


                    if (oAppt != null)
                    {
                        try
                        {
                            objInspWrap.Inspector = Inspector;
                            objInspWrap.MailItem = null;
                            objInspWrap.Key = WrapperID;
                            objInspWrap.WrapperClass = WrapperCol;
                            objInspWrap.TaskPane = null;
                            objInspWrap.Region = Region;
                            objInspWrap.Ribbon = null;
                            objInspWrap.AppointmentItem = oAppt;

                            // add wrapper class to the collection to keep it alive
                            WrapperCol.Add(WrapperID, objInspWrap);

                            WrapperID += 1;
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show(ex.Message);
                        }
                    }
                    break;
            }

            objInspWrap = null;
            oMail = null;
            oAppt = null;

            return WrapperID;
        }

        public void KillInsp(int WrapperID, System.Collections.SortedList WrapperCol)
        {
            // remove wrapper class from wrapper collection
            try { WrapperCol.Remove(WrapperID); }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }

}