namespace VSTO_CSOutlookTemplate
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Text;
    using System.Windows.Forms;
    using Outlook = Microsoft.Office.Interop.Outlook;
    using Office = Microsoft.Office.Core;
    using System.Reflection;
    using System.Runtime.InteropServices;

    [System.Runtime.InteropServices.ComVisibleAttribute(true)]
    public partial class ToolsOptionsPP : UserControl
    {
        //implements Outlook.PropertyPage

        private bool m_dirty;

        private Outlook.PropertyPageSite m_site;

        private string m_caption;

        public ToolsOptionsPP()
        {
            InitializeComponent();

            m_dirty = false;

            // HACK: uses reflection to call a private unsafe method!
            Type userControlType = typeof(System.Object);
            string assembly = userControlType.Assembly.CodeBase.Replace("mscorlib.dll", "System.Windows.Forms.dll");
            assembly = assembly.Replace("file:///", "");
            string assemblyName = System.Reflection.AssemblyName.GetAssemblyName(assembly).FullName;

            Type unsafeMethods = Type.GetType(System.Reflection.Assembly.CreateQualifiedName(assemblyName, "System.Windows.Forms.UnsafeNativeMethods"));

            Type oleObjectType = unsafeMethods.GetNestedType("IOleObject");
            System.Reflection.MethodInfo method = oleObjectType.GetMethod("GetClientSite");

            try
            {
                m_site = (Outlook.PropertyPageSite)method.Invoke(this, null);
            }
            catch
            {
                m_site = null;
            }
        }

        public void Apply() //Implements Microsoft.Office.Interop.Outlook.PropertyPage.Apply
        {
            if (m_dirty == true)
            {
                //do something to save properties

                m_dirty = false;
            }
        }

        public bool Dirty //Implements Microsoft.Office.Interop.Outlook.PropertyPage.Dirty
        {
            get
            {
                return m_dirty;
            }
        }


        public void GetPageInfo(ref string HelpFile, ref int HelpContext) //Implements Microsoft.Office.Interop.Outlook.PropertyPage.GetPageInfo
        {
            //show help file here
        }

        public void SetDirty()
        {
            m_dirty = true;

            m_site.OnStatusChange(); // tell Outlook the page is dirty
        }

        [DispId(-518)]
        public string Caption
        {
            // Return the OptionsPage Caption here.
            get { return m_caption; }
            set { m_caption = value; }
        }
    }
}